# !/bin/bash

ID=$1
IDSTRING=$(printf "%08d" $ID)

PATHIN="/work/boy/data/00_input/rec$IDSTRING/"
PATHOUT="/work/boy/data/02_preprocessed/rec${IDSTRING}pp/"

#we check if such a directory is existing
if [ ! -d $PATHIN ]; then
	echo "input path: $PATHIN not found" 
	exit
fi

#we make the output dir

mkdir -p "$PATHOUT/data"

#we copy the record file
#cp record.json $PATHOUT

##we search for the ID in recordlist.json
FIRSTLINE="$(grep -rn $ID ../00_input/recordlist.json  | cut -f1 -d:)"
LASTLINE=$(($FIRSTLINE+9))

#echo $FIRSTLINE
#we check if we got a result
if [ -z "$FIRSTLINE"  ]; then
   echo "error: $ID not found in file recordlist.json in folder ../00_input/";
   exit;
fi
#echo $LASTLINE

##write the header
FHEAD=$'{\n\t\"recordlist\":[\n\t\t{'
FTAIL=$'\t\t}\n\t]\n}'
RECORDFILE=$"${PATHOUT}/record.json"

#if the file exist, we delete it
[ -e $RECORDFILE ] && rm -f $RECORDFILE

echo $FHEAD >> "$RECORDFILE"
#we copy all needed file
sed -n "${FIRSTLINE},${LASTLINE}p" ../00_input/recordlist.json >> "$RECORDFILE" 
echo $FTAIL >> "$RECORDFILE"

#we will test if its d3 or d4
TESTD3="$(grep -rn D3 $RECORDFILE  | cut -f1 -d:)"
TESTD4="$(grep -rn D4 $RECORDFILE  | cut -f1 -d:)"

if [ ! -z "$TESTD3" ] ; then
   if [ ! -z "$TESTD4" ] ; then
   	echo "error during check $RECORDFILE for d3 or d4 cam configuration";
	exit; 
   fi
fi

#if the string for test3 is not empty, we have d4 
if [ -z "$TESTD3"  ]; then
   echo "d4 record";
   #cp './camera_*d3*xml' $PATHOUT
   #find . -iregex "camer*d3*xml" -exec cp {} $PATHOUT \;
   cp camera_center_d4.xml $PATHOUT
   cp camera_param_d4_n500.xml $PATHOUT
fi
# if the string for testd4 is not empty
if [ -z "$TESTD4"  ]; then 
   echo "d3 record";
   #cp '*./camera_d4*xml' $PATHOUT
   #find . -iregex "camer*d3*xml" -exec cp {} $PATHOUT \;
   cp camera_center_d3.xml $PATHOUT
   cp camera_param_d3_n500.xml $PATHOUT
fi

./testCenter.sh $ID


