#include "confcamera.h"

ConfCamera::ConfCamera()
{
    m_camCenterX = -1;
    m_camCenterY = -1;
    m_camRadius = -1;
    m_portAdress = 8080;
    m_camName = "foo";
}

int ConfCamera::camRadius() const
{
    return m_camRadius;
}

void ConfCamera::setCamRadius(int camRadius)
{
    m_camRadius = camRadius;
}

int ConfCamera::camCenterX() const
{
    return m_camCenterX;
}

void ConfCamera::setCamCenterX(int camCenterX)
{
    m_camCenterX = camCenterX;
}

int ConfCamera::camCenterY() const
{
    return m_camCenterY;
}

void ConfCamera::setCamCenterY(int camCenterY)
{
    m_camCenterY = camCenterY;
}

int ConfCamera::getPortAdress() const
{
    return m_portAdress;
}

void ConfCamera::setPortAdress(int portAdress)
{
    qDebug()<<"port: "<< portAdress;
    m_portAdress = portAdress;
}

QString ConfCamera::getCamName() const
{
    return m_camName;
}

void ConfCamera::setCamName(const QString &camName)
{
    m_camName = camName;
}


void ConfCamera::read(const QJsonObject &json)
{
    if(json.contains("name") && json["name"].isString())
        m_camName = json["name"].toString();
    else
        qWarning()<<"error during parse config file ";


    m_camCenterX = getValueInt(json, "camCenterX");
    if(m_camCenterX==-1)
        qWarning()<<"error during parse config file ";

    m_camCenterY = getValueInt(json, "camCenterY");
    if(m_camCenterX==-1)
        qWarning()<<"error during parse config file ";

    m_camRadius = getValueInt(json, "camRadius");
    if(m_camCenterX==-1)
        qWarning()<<"error during parse config file ";

    m_portAdress = getValueInt(json, "port");

    if(m_portAdress==-1)
        qWarning()<<"error during parse config file ";

    //small test
    if(m_portAdress!=8080&&m_portAdress!=8081)
        qWarning()<<"error during load port address"<<m_portAdress;


}

void ConfCamera::write(QJsonObject &json) const
{
    json["camCenterX"] = m_camCenterX;
    json["camCenterY"] = m_camCenterY;
    json["camRadius"] = m_camRadius;
    json["port"] = m_portAdress;
    json["name"] = m_camName;


}

int ConfCamera::getValueInt(const QJsonObject &json, QString jsonPattern)
{
    int value = -1;

    if (json.contains(jsonPattern) && json[jsonPattern].isDouble())
            value = json[jsonPattern].toInt();

    return value;
}
