#ifndef CONFCAMERA_H
#define CONFCAMERA_H

#include <QObject>
#include <QJsonObject>
#include <QDebug>

class ConfCamera
{
    Q_GADGET;

public:

    ConfCamera();

    void read(const QJsonObject &json);

    void write(QJsonObject &json) const;

    void print(int indentation = 0) const;

    int camRadius() const;
    void setCamRadius(int camRadius);

    int camCenterX() const;
    void setCamCenterX(int camCenterX);

    int camCenterY() const;
    void setCamCenterY(int camCenterY);

    int getPortAdress() const;
    void setPortAdress(int portAdress);

    QString getCamName() const;
    void setCamName(const QString &camName);

private:

    int m_camCenterX;
    int m_camCenterY;
    QString m_camName;
    int m_camRadius;
    int m_portAdress;

    //todo lense correction is something cam specific
    QString m_fileLenseCorrection;

    //!
    int getValueInt(const QJsonObject &json, QString jsonPattern);

};

#endif // CONFCAMERA_H
