#ifndef CONFIG_H
#define CONFIG_H

//qt
#include <QObject>
#include <QJsonObject>
#include <QDebug>
#include <QJsonArray>
#include <QJsonDocument>

//own
#include "confcamera.h"


class Config
{
    Q_GADGET;

public:
    Config();

    void read(const QJsonObject &json);
    void write(QJsonObject &json) const;

    //void print(int indentation = 0) const;

    QString storagePath() const;
    void setStoragePath(const QString &storagePath);

    int minDiskSpaceNeeded() const;
    void setMinDiskSpaceNeeded(int minDiskSpaceNeeded);

    //TODO radius we need
    //TODO read and write a array of cams1 ?

//    QString getFileLenseCorrection() const;
//    void setFileLenseCorrection(const QString &fileLenseCorrection);

    QList<ConfCamera> getCamList() const;
    void setCamList(const QList<ConfCamera> &camList);

    QString getGlobalRecordUIDListFile() const;
    void setGlobalRecordUIDListFile(const QString &globalRecordUIDListFile);

    int getRecordDurationInSec() const;
    void setRecordDurationInSec(int recordDurationInSec);

    //! @return the whole config in a human readable string format
    QString toString();

private:

    QString m_storagePath;
    QString m_globalRecordUIDListFile;

    //todo lense correction is something cam specific
    //QString m_fileLenseCorrection;
    int m_minDiskSpaceNeeded;
    int m_recordDurationInSec;
    QList<ConfCamera> m_camList;

    int getValueInt(const QJsonObject &json, QString jsonPattern);

};

#endif // CONFIG_H
