#ifndef MYHTTPSERVER_H
#define MYHTTPSERVER_H

#include <QCoreApplication>
#include <QNetworkInterface>
#include <iostream>
#include <QObject>
#include <QTcpSocket>
#include <QTcpServer>
#include <QJsonObject>
#include <QJsonDocument>
#include <QJsonArray>
#include <QDebug>
#include <QHttpPart>
#include <QNetworkReply>

//own
#include "confcamera.h"
#include "configmanager.h"
#include "asyncorder.h"


class MyHTTPserver : public QObject
{
    Q_OBJECT
public:
    enum STATE{
        STATE_RUN,
        STATE_ERROR
    };

    explicit MyHTTPserver(QObject *parent = 0);
    ~MyHTTPserver();
    QTcpSocket *socket ;

    bool initServer();

    MyHTTPserver::STATE getState();

    ConfCamera getConfig() const;
    void setConfig(const ConfCamera &config);

public slots:
    void myConnection();

    void cameraRecorderStateChanged(AsynCorder::STATE s);

signals:

    void emitStartCam();

    void emitStoppCam();

private:
    qint64 bytesAvailable() const;
    QTcpServer *server;
    ConfCamera m_config;
    AsynCorder::STATE m_camState;
signals:
};


#endif // MYHTTPSERVER_H
