
# ### Core BUILD ##################
message(*build camRecorder module: recorder)

#### QT Modules #######
QT       += core        # main function , threads and so on
#QT       += multimedia  # Audio Formats, Audio Device
#QT       += gui         # Gui Elements like Widgets
QT       += network     # for Network Elements like, QUdpSocket
#QT 	+= serialport  # serial port
#QT      += widgets     #for all widgets things

# for qt 5 or over TODO check right
#greaterThan(QT_MAJOR_VERSION, 4): QT += widgets  # use QWidget
#greaterThan(QT_MAJOR_VERSION, 4): QT += printsupport #Qprinter support

#not use some cool new features
#QMAKE_CXXFLAGS += -std=c++0x

#config flags
CONFIG  += qt       #use qt
#CONFIG  += debug    #use debug mode
CONFIG  += warn_on  #-wall

#template
DEFINES += RFT2_CORE_LIBRARY

#TEMPLATE = lib      #use template as lib
TEMPLATE = app      #use app template
TARGET   = recorder

#destination dir
DESTDIR  = ../../bin

#@see https://stackoverflow.com/questions/3984104/qmake-how-to-copy-a-file-to-the-output
# Copies the given files to the destination directory
defineTest(copyToDestdir) {
    files = $$1

    for(FILE, files) {
        DDIR = $$DESTDIR

        # Replace slashes in paths with backslashes for Windows
        win32:FILE ~= s,/,\\,g
        win32:DDIR ~= s,/,\\,g

        QMAKE_POST_LINK += $$QMAKE_COPY $$quote($$FILE) $$quote($$DDIR) $$escape_expand(\\n\\t)
    }

    export(QMAKE_POST_LINK)
}

##TODO: is not working that way
## copy the vimba file
#copyToDestdir("../../thirdParty/vimba1.4/libs/libVimbaCPP.so")
#copyToDestdir(../../thirdParty/vimba1.4/libs/libVimbaImageTransform.so)
#copyToDestdir(../../thirdParty/vimba1.4/libs/libVimbaC.so)

###### Dependency`s **********

##opencv lib support
include(../../config/opencv.pri)
##vimba 1.4 framework
include(../../config/vimba.pri)
##libarchive
#include(../../config/archive.pri)
##ffmpeg
##include(../../config/ffmpeg.pri)
##pistache
#include(../../config/pistache.pri)

#windows
win32{

message(* build for win32 not supported)
}

#######
#### Source and header

SOURCES += *.cpp

HEADERS += *.h

####

#OTHER_FILES += \
#    ../../config/dependencies.pri
