#include "recordinfo.h"

RecordInfo::RecordInfo()
{
    m_state = STATE_UNKNOWN;
//    m_place = ;
    m_UID =  -1;//UtilFactoryDataFileName::getUID();
    //! the id of the used cam
    m_camID = "none";
    m_dataHash = "none";

    m_timeStartSecUnix = -1;
    m_timeStartMS = -1;
    m_timeStoppSecUnix = -1;
    m_timeStoppMS = -1;
    //m_totalAmountSecondsRecorded = -1;
    m_amountFramesRecorded = -1;
    m_amountLostFrames = -1;
}


int RecordInfo::getValueInt(const QJsonObject &json, QString jsonPattern)
{
    int value = -1;

    if (json.contains(jsonPattern) && json[jsonPattern].isDouble())
        value = json[jsonPattern].toInt();

    return value;
}

void RecordInfo::read(const QJsonObject &json)
{

    if (json.contains("camID") && json["camID"].isString())
        m_camID = json["camID"].toString();
    else
        qWarning()<<"error during parse RecordInfo file, element #1";

    if (json.contains("dataHash") && json["dataHash"].isString())
        m_dataHash = json["dataHash"].toString();
    else
        qWarning()<<"error during parse RecordInfo file , element #2";

    m_state = (STATE) getValueInt(json, "state");
    if(m_state==STATE_UNKNOWN)
        qWarning()<<"error during parse RecordInfo file, element #3 ";

    m_UID = getValueInt(json, "UID");
    if(m_UID==-1)
        qWarning()<<"error during parse RecordInfo file, element #4 ";

    m_timeStartSecUnix = getValueInt(json, "timeStartSecUnix");
    if(m_timeStartSecUnix==-1)
        qWarning()<<"error during parse RecordInfo file, element #5 ";

    m_timeStoppSecUnix = getValueInt(json, "timeStoppSecUnix");
    if(m_timeStoppSecUnix==-1)
        qWarning()<<"error during parse RecordInfo file, element #6 ";

    m_timeStartMS = getValueInt(json, "timeStartMS");
    if(m_timeStartMS==-1)
        qWarning()<<"error during parse RecordInfo file, element #7 ";

    m_timeStoppMS = getValueInt(json, "timeStoppMS");
    if(m_timeStoppMS==-1)
        qWarning()<<"error during parse RecordInfo file, element #8 ";

//    m_totalAmountSecondsRecorded = getValueInt(json, "totalAmountSecondsRecorded");
//    if(m_totalAmountSecondsRecorded==-1)
//        qWarning()<<"error during parse RecordInfo file, element #9 ";

    m_amountFramesRecorded = getValueInt(json, "amountFramesRecorded");
    if(m_amountFramesRecorded==-1)
        qWarning()<<"error during parse RecordInfo file, element #10 ";

    m_amountLostFrames = getValueInt(json, "amountLostFrames");
    if(m_amountLostFrames==-1)
        qWarning()<<"error during parse RecordInfo file, element #11 ";

}

void RecordInfo::write(QJsonObject &json) const
{

    json["state"] = (int) m_state;
    json["UID"] = m_UID;
    json["camID"] = m_camID;
    json["dataHash"] = m_dataHash;
    json["timeStartSecUnix"] = m_timeStartSecUnix;
    json["timeStartMS"] = m_timeStartMS;
    json["timeStoppSecUnix"] = m_timeStoppSecUnix;
    json["timeStoppMS"] = m_timeStoppMS;
//    json["totalAmountSecondsRecordfoed"] = m_totalAmountSecondsRecorded;
    json["amountFramesRecorded"] = m_amountFramesRecorded;
    json["amountLostFrames"] = m_amountLostFrames;
}

int RecordInfo::getUID() const
{
    return m_UID;
}

void RecordInfo::setUID(int UID)
{
    m_UID = UID;
}

RecordInfo::STATE RecordInfo::getState() const
{
    return m_state;
}

void RecordInfo::setState(const STATE &state)
{
    m_state = state;
}

QString RecordInfo::getCamID() const
{
    return m_camID;
}

void RecordInfo::setCamID(const QString &camID)
{
    m_camID = camID;
}

QString RecordInfo::getDataHash() const
{
    return m_dataHash;
}

void RecordInfo::setDataHash(const QString &dataHash)
{
    m_dataHash = dataHash;
}

int RecordInfo::getTimeStartSecUnix() const
{
    return m_timeStartSecUnix;
}

void RecordInfo::setTimeStartSecUnix(int timeStartSecUnix)
{
    m_timeStartSecUnix = timeStartSecUnix;
}

int RecordInfo::getTimeStartMS() const
{
    return m_timeStartMS;
}

void RecordInfo::setTimeStartMS(int timeStartMS)
{
    m_timeStartMS = timeStartMS;
}

int RecordInfo::getTimeStoppSecUnix() const
{
    return m_timeStoppSecUnix;
}

void RecordInfo::setTimeStoppSecUnix(int timeStoppSecUnix)
{
    m_timeStoppSecUnix = timeStoppSecUnix;
}

int RecordInfo::getTimeStoppMS() const
{
    return m_timeStoppMS;
}

void RecordInfo::setTimeStoppMS(int timeStoppMS)
{
    m_timeStoppMS = timeStoppMS;
}

//int RecordInfo::getTotalAmountSecondsRecorded() const
//{
//    return m_totalAmountSecondsRecorded;
//}

//void RecordInfo::setTotalAmountSecondsRecorded(int totalAmountSecondsRecordInfoed)
//{
//    m_totalAmountSecondsRecorded = totalAmountSecondsRecordInfoed;
//}

int RecordInfo::getAmountFramesRecorded() const
{
    return m_amountFramesRecorded;
}

void RecordInfo::setAmountFramesRecorded(int amountFramesRecordInfoed)
{
    m_amountFramesRecorded = amountFramesRecordInfoed;
}

int RecordInfo::getAmountLostFrames() const
{
    return m_amountLostFrames;
}

void RecordInfo::setAmountLostFrames(int amountLostFrames)
{
    m_amountLostFrames = amountLostFrames;
}
