#ifndef RECORDINFO_H
#define RECORDINFO_H

//qt
#include <QObject>
#include <QJsonObject>
#include <QDebug>
#include <QJsonArray>

//own
//#include "utilfactorydatafilename.h"

class RecordInfo
{
    Q_GADGET;

public:

    enum STATE{
        STATE_UNKNOWN,
        STATE_RECORDING_AT_THE_MOMENT,
        STATE_RECORDED_WITH_CRITICAL_FAILURE,
        STATE_RECORDED_WITH_SUCCESS
    };

//    enum STOREDPLACE {
//        PLACE_UNKNOWN,
//        PLACE_VM,
//        PLACE_CLUSTER
//    };

    RecordInfo();

    void read(const QJsonObject &json);
    void write(QJsonObject &json) const;

    int getUID() const;
    void setUID(int UID);

    STATE getState() const;
    void setState(const STATE &state);

    QString getCamID() const;
    void setCamID(const QString &camID);

    QString getDataHash() const;
    void setDataHash(const QString &dataHash);

    int getTimeStartSecUnix() const;
    void setTimeStartSecUnix(int timeStartSecUnix);

    int getTimeStartMS() const;
    void setTimeStartMS(int timeStartMS);

    int getTimeStoppSecUnix() const;
    void setTimeStoppSecUnix(int timeStoppSecUnix);

    int getTimeStoppMS() const;
    void setTimeStoppMS(int timeStoppMS);

//    int getTotalAmountSecondsRecorded() const;
//    void setTotalAmountSecondsRecorded(int totalAmountSecondsRecorded);

    int getAmountFramesRecorded() const;
    void setAmountFramesRecorded(int amountFramesRecorded);

    int getAmountLostFrames() const;
    void setAmountLostFrames(int amountLostFrames);

private:

    //TODO: the start time reference from the first frame ?

    //! the unique id of the record
    int m_UID;
    STATE m_state;
 //   STOREDPLACE m_place;
    //! the id of the used cam
    QString m_camID;
    QString m_dataHash;
    int m_timeStartSecUnix;
    int m_timeStartMS;
    int m_timeStoppSecUnix;
    int m_timeStoppMS;
//    int m_totalAmountSecondsRecorded;
    int m_amountFramesRecorded;
    int m_amountLostFrames;

    int getValueInt(const QJsonObject &json, QString jsonPattern);

};

#endif // RECORDINFO_H
