#include "recordlist.h"

RecordList::RecordList()
{
    m_recordList = QList<RecordInfo>();
}

bool RecordList::updateRecord(RecordInfo rec)
{
    int i=0;
    bool success = false;
    for(;i<m_recordList.size();i++)
    {
        if(rec.getUID()==m_recordList.at(i).getUID())
        {
            success = true;
            //we update the record
            m_recordList.replace(i,rec);
        }
    }

    //    //save to file
    //    if(ConfigManager::writeRecordList())
    //        qWarning()<<"error during save record list";

    return success;
}

RecordInfo RecordList::getLastRecordInfo()
{
   return m_recordList.last();
}

bool RecordList::appendRecord(RecordInfo rec)
{
    if(existUIDinList(rec.getUID()))
    {
        qWarning()<<"conflict with uid of record dectected";
        return false;
    }
    else
    {
        m_recordList.append(rec);

        //        //save to file
        //        if(ConfigManager::writeRecordList())
        //            qWarning()<<"error during save record list";

    }
    return true;
}

bool RecordList::existUIDinList(int uid)
{
    foreach (RecordInfo recTmp, m_recordList) {
        int uidTmp = recTmp.getUID();

        if(uid == uidTmp)
            return true;
    }

    return false;
}

QList<RecordInfo> RecordList::recordList() const
{
    return m_recordList;
}

void RecordList::setRecordList(const QList<RecordInfo> &recordList)
{
    m_recordList = recordList;
}

void RecordList::read(const QJsonObject &json)
{
    //    if (json.contains("path") && json["path"].isString())
    //        m_storagePath = json["path"].toString();

    //record list
    if (json.contains("recordlist") && json["recordlist"].isArray()) {
        QJsonArray recordArray = json["recordlist"].toArray();
        m_recordList.clear();
        m_recordList.reserve(recordArray.size());
        for (int camListIndex = 0; camListIndex < recordArray.size(); ++camListIndex) {
            QJsonObject recordObject = recordArray[camListIndex].toObject();
            RecordInfo recordTmp;
            recordTmp.read(recordObject);
            m_recordList.append(recordTmp);
        }
    }

}

void RecordList::write(QJsonObject &json) const
{
    QJsonArray recordArray;
    if(!m_recordList.isEmpty())
    {
        for(int i=0;i<m_recordList.size();i++)
        {
            RecordInfo recordTmp = m_recordList.at(i);

            //foreach (const RecordInfo recordTmp, m_recordList) {
            QJsonObject recordObject;
            recordTmp.write(recordObject);
            recordArray.append(recordObject);
        }
        json["recordlist"] = recordArray;
    }
    else
        json["recordlist"] = "null";

}
