#ifndef RECORDLIST_H
#define RECORDLIST_H


//qt
#include <QObject>
#include <QJsonObject>
#include <QDebug>
#include <QJsonArray>
#include <QList>

//own
#include "recordinfo.h"
//#include "configmanager.h"

//write promote a proto class
//class RecordInfo;

class RecordList
{
    Q_GADGET;

public:

    RecordList();

    void read(const QJsonObject &json);
    void write(QJsonObject &json) const;

    //! add the record to the list and checks if UID is colling with all present ones
    bool appendRecord(RecordInfo rec);

    //! we update the record in the list
    bool updateRecord(RecordInfo rec);

    //! @return true if uid is already in list
    //! @return false if not
    bool existUIDinList(int uid);

    RecordInfo getLastRecordInfo();

    QList<RecordInfo> recordList() const;
    void setRecordList(const QList<RecordInfo> &recordList);

private:
    QList<RecordInfo> m_recordList; //maybe use QList<Rec*> ?
};

#endif // RECORDLIST_H
