#include "startmoment.h"

StartMoment::StartMoment()
{
    m_tStartCamS=0;
    m_tStartCamMS=0;
    m_tStartServerS=0;
    m_tStartServerMS=0;
}

QPair<quint64,quint64> StartMoment::getDiff(quint64 camSeconds, quint64 camMSeconds)
{
    //qDebug()<<"server time:"<<m_tStartServerS<<";"<<m_tStartServerMS<<" cam time:"<< m_tStartCamS<<";"<<m_tStartCamMS;
    //diff of camera system
    quint64 camTimeFullms = (camSeconds  * 1000) + camMSeconds;
    quint64 camStartTimeFullms = ( m_tStartCamS * 1000 ) + m_tStartCamMS;

    quint64 diffFullMS = camTimeFullms- camStartTimeFullms;


    quint64 diffS = quint64 (diffFullMS / 1000 );
    quint64 diffMS = diffFullMS % 1000 ;

    //    //TODO test for a upper bound

    //    //this produces a overflow !
    //    quint64 diffMSeconds = qAbs( camMSeconds- m_tStartCamMS) ;
    //    //bug fix
    //    quint64 diffMSeconds = 0 ;

    //    if( camMSeconds> m_tStartCamMS) !!! SOLUTION ??
    //    if( camMSeconds< m_tStartCamMS) !! ??


    QPair<quint64,quint64> timeStamp;
    timeStamp.second = m_tStartServerMS + diffMS;

    if(timeStamp.second > 1000 ) //if ms + ms -> produced > 1000 ms = 1 s
    {
        timeStamp.second = timeStamp.second % 1000;
        diffS += 1; //we add a second
    }
    timeStamp.first = m_tStartServerS + diffS;

    return timeStamp;
}

quint64 StartMoment::tStartCamS() const
{
    return m_tStartCamS;
}

void StartMoment::setTStartCamS(const quint64 &tStartCamS)
{
    m_tStartCamS = tStartCamS;
}

quint64 StartMoment::tStartCamMS() const
{
    return m_tStartCamMS;
}

void StartMoment::setTStartCamMS(const quint64 &tStartCamMS)
{
    m_tStartCamMS = tStartCamMS;
}

quint64 StartMoment::tStartServerS() const
{
    return m_tStartServerS;
}

void StartMoment::setTStartServerS(const quint64 &tStartServerS)
{
    m_tStartServerS = tStartServerS;
}

quint64 StartMoment::tStartServerMS() const
{
    return m_tStartServerMS;
}

void StartMoment::setTStartServerMS(const quint64 &tStartServerMS)
{
    m_tStartServerMS = tStartServerMS;
}
