#!/bin/bash
# will copy X jpg and txt random files from in to out

if [ $# -eq 3 ]; then
    echo "will draw and copy $1 file in dir: $2 to dir: $3"
else
    echo "arg parse error, use like: ./draw 2000 /input /output"
    exit
fi

AMOUNT=$1
IN=$2
OUT=$3

if [ ! -d "$IN" ]; then
	echo "error dir: $2 not existing"
	exit
fi
#
if [ ! -d "$OUT" ]; then
  	mkdir -p $OUT
fi

#TODO test number of files
COUNTER=0

filesJPG=($IN/*.jpg)                    #creates an array of all the files
filesTXT=($IN/*.tt)

if [ ! -f "${filesJPG[0]}" ]; then
        echo "no jpg files in dir $IN"
        exit
fi



#echo $filesTXT
#echo $filesJPG
filecount="${#filesJPG[@]}"         #determines the length of the array

#field=()

while [  $COUNTER -lt $AMOUNT ]; do

	echo "$COUNTER of $AMOUNT"
	#we producing random number, until we found a non used one" 
	while : ; do
	
		randomid=$(shuf -i "0-$filecount" -n 1)
		#echo $randomid

		##randomid=$((RANDOM % filecount)) #uses $RANDOM to choose a random number between 0 and $filecount
		#!! RANDOM has a limit by 0 and 32767 , 16 bit
	
		filetomoveJPG="${filesJPG[$randomid]}" #the random file wich we'll move
		filetomoveTXT="${filesTXT[$randomid]}" #the random file wich we'll move
	
		#we split the filename
		#		IFS='\//' read -r -a array <<< "$filetomoveJPG"
		#echo "0: $filetomoveJPG"
		#echo "1: ${array[0]}"
		#echo "2: ${array[1]}"
#		echo "3: $( basename $filetomoveJPG)" #use basename https://stackoverflow.com/questions/13767252/ubuntu-bash-script-how-to-split-path-by-last-slash 
		TEST="$OUT/$( basename $filetomoveJPG)"
#		echo "test : $TEST" 	

		if [ -f $TEST ]; then
			echo "      file: $filetomoveJPG exists already"
		else
			break
		fi
	done

	#echo "---------------"
	#echo "$filetomoveJPG"

	#check if random already used
	#field+=("$input")

	# is this double check here needed  ?????
	if [ ! -f $filetomoveJPG ]; then
                echo "file $filetomoveJPG not found"
	else
	
		echo "      copy $filetomoveTXT and $filetomoveJPG to $OUT"
 		cp "$filetomoveTXT" $OUT            #will actually copy the file
		if [ $? -ne 0 ]; then
    			echo "FAILED to copy $filetomoveTXT with id: $randomid"
		fi

		#DCHECK="$OUT$( basename $filetomoveJPG)"
		#echo "d-check: $DCHECK"	
		#sleep 1 
		#if [ ! -f "$DCHECK" ]; then
		#	echo "cp called but file: $DCHECK not found" 
		#fi

			
        	cp "$filetomoveJPG" $OUT   	 #will actually copy the file
                if [ $? -ne 0 ]; then
                        echo "FAILED to copy $filetomoveJPG"
                fi


		let COUNTER=COUNTER+1 		#counter++
        fi

done


#perform a double check
AMOUNTDONE="$(ls $OUT/*jpg | wc -l )" 
echo "###"
echo "we copied $AMOUNTDONE of $AMOUNT"  
