#!/usr/bin/python3

# more background:
# https://photographylife.com/sensor-crop-factors-and-equivalence

from pprint import pprint as pp
from math import *

sensor_size_to_crop_factor={
#can also calculate it manually by using diagonal sensor size and compare to full frame diagonal sensor size
#https://shuttermuse.com/calculate-cameras-crop-factor/#digital-sensor-sizes-and-their-crop-factor
"full frame":1, #reference: 36mm x 24mm -> diag:43.27
"APS-C (Nikon etc.)":1.5,
"APS-C (Canon)":1.6,
'micro four thirds"':2,
'1"':2.7,
'2/3"':5.5,
'1/1.8"':4.8,
'1/2.3"':5.6,
'1/2.5"':6,
}

focal_len_2_AOV_full_frame={
11:117.1,
14:104.3,
16:96.7,
24:73.7,
35:54.4,
50:39.6,
85:23.9,
100:20.4,
150:13.7,
}

#equivalent_focal_length = focal_length_full_frame * crop_factor
#fov - field of view (= horizontal angle of view)
#size_subject
#distance of subject

def calc_fov(sensor_width_mm,f):
	# for sensor_size, crop_factor in sensor_size_to_crop_factor:
		# todo
	# sensor_size='2/3"'
	# crop_factor=sensor_size_to_crop_factor[sensor_size]
	# pp(sensor_size)
	# pp(crop_factor)

	fov=2*atan(sensor_width_mm/(2*f)) * 180/pi #convert to degrees with 180/pi, same as degrees(...)
	fov=round(fov,2)
	return fov



def calc_distance_to_subject(size_subject_cm, fov):
	'''calc distance_to_subject from size_subject and fov using trigonometrics'''
	'''depending on lense, the distance_to_subject is fixed or a minimum distance from the img plane'''

	# distance_to_subject = (size_subject/2) / tan(radians(fov))
	# distance_to_subject = round(distance_to_subject,2)

	return distance_to_subject

def main():
	size_subject_cm=50
	sensor_width_mm=36
	f=11
	fov=calc_fov(sensor_width_mm,f)
	pp(f"fov: {fov}")

	d=calc_distance_to_subject(size_subject_cm,fov)
	pp(f"distance_to_subject: {d}")



if __name__ == '__main__':
	main()


# formulae:
# AOV (in degrees) = 2 ArcTan( sensor width / (2 X focal length)) * (180/π)
# size_subject = 2 * (Tan (AOV/2) X Distance_to_Subject)

